/*=====================================================================
processlist.cpp
---------------
File created by ClassTemplate on Sun Mar 20 17:33:43 2005

Copyright (C) Nicholas Chapman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

http://www.gnu.org/copyleft/gpl.html.
=====================================================================*/
#include "processlist.h"


BEGIN_EVENT_TABLE(ProcessList, wxListCtrl)
	EVT_LIST_ITEM_SELECTED(PROCESS_LIST, ProcessList::OnSelected)
END_EVENT_TABLE()

ProcessList::ProcessList(wxWindow *parent, const wxPoint& pos,
               const wxSize& size)
:	wxListCtrl(parent, PROCESS_LIST, pos, size, wxLC_REPORT)
{
	selected_process = 0;

	wxListItem itemCol;
    itemCol.m_mask = wxLIST_MASK_TEXT | wxLIST_MASK_IMAGE;
    itemCol.m_text = _T("Process");
    itemCol.m_image = -1;
    InsertColumn(0, itemCol);
	SetColumnWidth(0, 200);


	ProcessInfo::enumProcesses(this->processes);
	for(int i=0; i<processes.size(); ++i)
	{
		long tmp = this->InsertItem(i, "", -1);
		SetItemData(tmp, i);
		this->SetItem(i, 0, processes[i].getName().c_str());
	}

}


ProcessList::~ProcessList()
{
	
}

void ProcessList::OnSelected(wxListEvent& event)
{
	this->selected_process = event.m_itemIndex;
}

const ProcessInfo* ProcessList::getSelectedProcess()
{
	if(selected_process >= 0 && selected_process < processes.size())
	{
		return &processes[selected_process];
	}
	else
		return NULL;
}



