/*=====================================================================
proclist.h
----------
File created by ClassTemplate on Tue Mar 15 21:13:18 2005

Copyright (C) Nicholas Chapman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

http://www.gnu.org/copyleft/gpl.html.
=====================================================================*/
#ifndef __PROCLIST_H_666_
#define __PROCLIST_H_666_


#include "lineinfo.h"
#include <wx/wx.h>
#include <wx/listctrl.h>
#include <string>
class SourceView;




/*=====================================================================
ProcList
--------

=====================================================================*/
class ProcList : public wxListCtrl
{
public:
	/*=====================================================================
	ProcList
	--------
	
	=====================================================================*/
	ProcList(wxWindow *parent, const wxWindowID id, const wxPoint& pos,
               const wxSize& size, long style, SourceView* sourceview);

	virtual ~ProcList();

	void OnSelected(wxListEvent& event);

	void loadFromPath(const std::string& proclistpath, const std::string& ipcountspath);

private:
	wxListItemAttr m_attr;

    DECLARE_EVENT_TABLE()

	std::map<std::string, LINEINFOMAP > fileinfo;

	SourceView* sourceview;
};


// IDs for the menu commands
enum
{
    LIST_ABOUT,
    LIST_QUIT,

    /*LIST_LIST_VIEW,
    LIST_ICON_VIEW,
    LIST_ICON_TEXT_VIEW,
    LIST_SMALL_ICON_VIEW,
    LIST_SMALL_ICON_TEXT_VIEW,
    LIST_REPORT_VIEW,
    LIST_VIRTUAL_VIEW,

    LIST_DESELECT_ALL,
    LIST_SELECT_ALL,
    LIST_DELETE_ALL,
    LIST_DELETE,
    LIST_ADD,
    LIST_EDIT,
    LIST_SORT,
    LIST_SET_FG_COL,
    LIST_SET_BG_COL,
    LIST_TOGGLE_MULTI_SEL,
    LIST_TOGGLE_FIRST,
    LIST_SHOW_COL_INFO,
    LIST_SHOW_SEL_INFO,
    LIST_FOCUS_LAST,
    LIST_FREEZE,
    LIST_THAW,*/

    LIST_CTRL                   = 1000
};


#endif //__PROCLIST_H_666_




