/*=====================================================================
profilergui.cpp
---------------
File created by ClassTemplate on Sun Mar 13 18:16:34 2005

Copyright (C) Nicholas Chapman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

http://www.gnu.org/copyleft/gpl.html.
=====================================================================*/
#include "profilergui.h"

#include "mainwin.h"
#include "threadpicker.h"
#include "../profiler/profilerthread.h"
#include "../profiler/symbolinfo.h"
#include "../utils/stringutils.h"
ProfilerGUI::ProfilerGUI()
{
	
}


ProfilerGUI::~ProfilerGUI()
{
	
}


IMPLEMENT_APP(ProfilerGUI)


bool ProfilerGUI::OnInit()
{
	::doStringUtilsUnitTests();

	//------------------------------------------------------------------------
	//allow the user to choose the process to profiler
	//------------------------------------------------------------------------
	ThreadPicker threadpicker;
	threadpicker.ShowModal();

	if(threadpicker.getButtonPressed() != ThreadPicker::OKAY)
		return false;

	if(threadpicker.getSelectedProcess())
	{
		if(!threadpicker.getSelectedProcess()->threads.empty())
		{
			//------------------------------------------------------------------------
			//get a handle to the target thread
			//------------------------------------------------------------------------
			HANDLE threadhandle = OpenThread(	THREAD_ALL_ACCESS,			//DWORD dwDesiredAccess,
												FALSE,						//BOOL bInheritHandle,
												threadpicker.getSelectedProcess()->threads[0].getID()//DWORD dwThreadId
												);

			//------------------------------------------------------------------------
			//create the profiler thread
			//------------------------------------------------------------------------
			ProfilerThread* profilerthread = new ProfilerThread(
												threadhandle, //thread to target
												threadpicker.getSelectedProcess()->getID(),
												//10000, //do N samples
												false);//don't kill target when completed

				
			//------------------------------------------------------------------------
			//start the profiler thread
			//------------------------------------------------------------------------
			profilerthread->launch();

			wxMessageDialog okdialog(NULL, "Press OK to stop profiling and display collected results.", "Profiling...");
			okdialog.ShowModal();

			profilerthread->commit_suicide = true;

			WaitForSingleObject(profilerthread->getHandle(), INFINITE);
		}		
	}
	else
	{
		return false;
	}

	/*if(argc < 3)
	{
		wxMessageDialog dialog(NULL, std::string("Not enough args\n" + 
			std::string("The proccounts and ipcounts files need to be supplied on the command line, eg: \n") + std::string(argv[0])
				+ " somepath\\proccounts.txt somepath\\ipcounts.txt").c_str(),
				"Error");
		dialog.ShowModal();
		return false;
	}*/

    // create the main application window
    //MainWin *frame = new MainWin(_T("Profiler"), argv[1], argv[2],
     //                            wxPoint(50, 50), wxSize(700, 500));

	MainWin *frame = new MainWin(_T("Sleepy"), "Proccounts.txt", "ipcounts.txt",
                                wxPoint(50, 50), wxSize(700, 500));


    // and show it (the frames, unlike simple controls, are not shown when
    // created initially)
    frame->Show(TRUE);

    // success: wxApp::OnRun() will be called which will enter the main message
    // loop and the application will run. If we returned FALSE here, the
    // application would exit immediately.
    return TRUE;
}


