/*=====================================================================
threadpicker.cpp
----------------
File created by ClassTemplate on Sun Mar 20 17:12:56 2005

Copyright (C) Nicholas Chapman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

http://www.gnu.org/copyleft/gpl.html.
=====================================================================*/
#include "threadpicker.h"


BEGIN_EVENT_TABLE(ThreadPicker, wxDialog)
    EVT_BUTTON(-1, ThreadPicker::OnButton)
	EVT_PAINT(ThreadPicker::OnPaint)
END_EVENT_TABLE()

const int TP_BORDER_WIDTH = 10;

ThreadPicker::ThreadPicker()
:	wxDialog(NULL, -1, wxString(_T("Select A Process to Profile.")), wxPoint(100, 100),
	wxSize(400+TP_BORDER_WIDTH*2, 500))
{
	buttonpressed = NO_BUTTON;

	ok_button = new wxButton(this, -1, _T("Ok"), wxPoint(TP_BORDER_WIDTH, 400 + TP_BORDER_WIDTH*2));

	cancel_button = new wxButton(this, wxID_CANCEL, _T("Cancel"), wxPoint(TP_BORDER_WIDTH + 75, 400 + TP_BORDER_WIDTH*2));

	processlist = new ProcessList(this, wxPoint(TP_BORDER_WIDTH, TP_BORDER_WIDTH), wxSize(400, 400));

	//wxImage* image = new wxImage("post.jpg");
	//bitmap = new wxBitmap(*image); 

	SetAutoLayout(TRUE);
}


ThreadPicker::~ThreadPicker()
{
	
}

void ThreadPicker::OnButton(wxCommandEvent& event)
{
	if ( event.GetEventObject() == ok_button )
    {
		buttonpressed = OKAY;
		this->Close();
    }
    else if ( event.GetEventObject() == cancel_button )
    {
		buttonpressed = CANCEL;
		this->Close();
    }
    else
    {
        event.Skip();
    }
}

const ProcessInfo* ThreadPicker::getSelectedProcess()
{
	return processlist->getSelectedProcess();
}

void ThreadPicker::OnPaint(wxCommandEvent& event)
{
	wxPaintDC dc(this);

	//dc.DrawBitmap(*bitmap, 400, 0, false);

	event.Skip();

}

/*
unsigned int ThreadPicker::getSelectedThread()
{
	const ProcessInfo* info = processlist->getSelectedProcess();

	if(info)
	{
		return info->threads[0].getID();
	}

	return 0;
}
*/






